From: Kevin Daudt <compufr...@gmail.com>

rebase learned to stash changes when it encounters a dirty work tree, but
git pull --rebase does not.

Only verify if the working tree is dirty when rebase.autostash is not
enabled.

Signed-off-by: Kevin Daudt <m...@ikke.info>
Helped-by: Paul Tan <pyoka...@gmail.com>
---
 git-pull.sh     |  5 ++++-
 t/t5520-pull.sh | 12 ++++++++++++
 2 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/git-pull.sh b/git-pull.sh
index 0917d0d..f0a3b6e 100755
--- a/git-pull.sh
+++ b/git-pull.sh
@@ -239,7 +239,10 @@ test true = "$rebase" && {
                        die "$(gettext "updating an unborn branch with changes 
added to the index")"
                fi
        else
-               require_clean_work_tree "pull with rebase" "Please commit or 
stash them."
+               if [ $(git config --bool --get rebase.autostash || echo false) 
= false ]
+               then
+                       require_clean_work_tree "pull with rebase" "Please 
commit or stash them."
+               fi
        fi
        oldremoteref= &&
        test -n "$curr_branch" &&
diff --git a/t/t5520-pull.sh b/t/t5520-pull.sh
index 925ad49..d06119f 100755
--- a/t/t5520-pull.sh
+++ b/t/t5520-pull.sh
@@ -135,6 +135,18 @@ test_expect_success 'pull --rebase dies early with dirty 
working directory' '
        test_cmp file expect
 '
 
+test_expect_success 'pull --rebase succeeds with dirty working directory and 
rebase.autostash set' '
+       test_config branch.to-rebase.rebase true &&
+       test_config rebase.autostash true &&
+       git checkout HEAD -- file &&
+       echo dirty > new_file &&
+       git add new_file &&
+       git pull . copy &&
+       test $(git rev-parse HEAD^) = $(git rev-parse copy) &&
+       test $(cat new_file) = dirty &&
+       test "$(cat file)" = "modified again"
+'
+
 test_expect_success 'pull.rebase' '
        git reset --hard before-rebase &&
        test_config pull.rebase true &&
-- 
2.4.2

--
To unsubscribe from this list: send the line "unsubscribe git" in
the body of a message to majord...@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html

Reply via email to